<template>
    <div class="container"
         ref="container"
         @keydown.delete="deleteCurrentTag"
         tabindex="0">
        <canvas id="transformationCanvas" hidden></canvas>
        <v-stage
            ref="stage"
            :config="configKonva"
            @mousedown="handleStageMouseDown"
            @touchstart="handleStageMouseDown"
        >
            <v-layer ref="layer">
                <v-image
                        ref="image"
                        :config="{
                            image: currentImage,
                            x: stageWidth/2 - currentImage.width/2,
                            y: stageHeight/2 - currentImage.height/2
                        }">
                </v-image>
                <v-circle
                        @transformend="handleTransformEnd"
                        @dragstart="handleCircleDragStart"
                        @dragend="handleCircleDragEnd"
                        v-for="item in filteredCircles"
                        :key="item.id"
                        :config="item"
                ></v-circle>
                <v-text
                        @dblclick="handleTextDoubleClick(item.id)"
                        ref="texts"
                        v-for="item in filteredTextTags"
                        :key="item.id"
                        :config="item">
                </v-text>
                <v-transformer ref="transformer" />
            </v-layer>
        </v-stage>
    </div>
</template>

<script>
  export default {
    name: 'VideoCanvas',
    props: {
      circles: {
        type: Array
      },
      textTags: {
        type: Array
      },
      subImages: {
        type: Array
      },
      stageHeight: {
        type: Number
      },
      stageWidth: {
        type: Number
      },
      strokeWidth: {
        type: Number
      },
      selectedCircle: {
        type: String
      },
      deleteCurrentTag: {
        type: Function
      },
      imagesToTag: {
        type: Array
      },
      imageNbr: {
        type: Number
      }
    },
    data() {
      return {
        dragItemId: null,
        configKonva: {
          width: this.stageWidth,
          height: this.stageHeight
        },
        selectedShapeName: this.selectedCircle,
        currentImage: this.imagesToTag[this.imageNbr],
        // currentImage: new window.Image()
        textEditing: false,
        hiddenTextNode: null,
      };
    },
    watch: {
      selectedCircle: function(newVal) {
        this.selectedShapeName = newVal;
        this.updateTransformer();
      },
      imageNbr: function(newVal) {
        this.imageNbr = newVal;
        this.currentImage = this.imagesToTag[newVal];
        this.deselectCircle();
      }
    },
    computed: {
        filteredCircles() {
          return this.circles.filter(item => item.linkedImage === this.imageNbr);
        },
        filteredTextTags() {
          return this.textTags.filter(item => item.linkedImage === this.imageNbr);
        }
    },
    methods: {
      deselectCircle() {
        this.selectedShapeName = '';
        this.changeSelectedCircle();
        this.updateTransformer();
      },
      retrieveImage(event){
        const canvas = this.$refs.stage.getNode().toCanvas();
        const ctx = canvas.getContext("2d");

        // const sx = event.x() - event.radius() * event.scaleX();
        // const sy = event.y() - event.radius() * event.scaleY();
        // const sw = 2 * event.radius() * event.scaleX();
        // const sh = 2 * event.radius() * event.scaleY();

        const inSquareSideX = Math.cos(Math.PI/4) * 2 *event.radius() * event.scaleX();
        const inSquareSideY = Math.cos(Math.PI/4) * 2 *event.radius() * event.scaleY();

        const sx = event.x() - inSquareSideX / 2;
        const sy = event.y() - inSquareSideY / 2;
        const sw = inSquareSideX;
        const sh = inSquareSideY;

        const image = ctx.getImageData(sx, sy, sw, sh);

        const canvas2 = document.getElementById("transformationCanvas");
        canvas2.width  = sw;
        canvas2.height = sh;
        const ctx2 = canvas2.getContext("2d");
        ctx2.putImageData(image, 0, 0);

        // const img = document.createElement("img");
        // img.src = canvas2.toDataURL("image/png");
        // document.body.appendChild(img);
        return canvas2.toDataURL("image/png");
      },
      changeSelectedCircle() {
        this.$emit('circleSelectionChanged', this.selectedShapeName);
      },
      handleCircleDragStart() {
        const textElem = this.$refs.texts.find(item => item.$props.config.id === '-'+this.selectedCircle);
        const textNode = textElem.getNode();
        this.hiddenTextNode = textNode;
        textNode.hide();
      },
      handleCircleDragEnd(e) {
        // shape is transformed, let us save new attrs back to the node
        // find element in our state
        const circle = this.filteredCircles.find(r => r.name === this.selectedShapeName);
        // update the state
        circle.x = e.target.x();
        circle.y = e.target.y();
        circle.rotation = e.target.rotation();
        circle.scaleX = e.target.scaleX();
        circle.scaleY = e.target.scaleY();
        circle.radius = 50;
        circle.strokeWidth = 5;
        const subImage = this.retrieveImage(e.target);
        this.$emit('circleChanged', circle);
        this.$emit('textChanged', {x: e.target.x(), y: e.target.y()});
        this.$emit('subImageChanged', {imageURL: subImage});
        this.hiddenTextNode.show();
      },
      handleTextDoubleClick(textId) {
        // Retrieve the text elem which is focussed
        const textElem = this.$refs.texts.find(item => item.$props.config.id === textId);

        // Retrieve the position of the text
        const textNode = textElem.getNode();
        const textPosition = textNode.getAbsolutePosition();

        // Retrieve the position of the stage on the page
        const stageBox = this.$refs.stage.getStage().container().getBoundingClientRect();

        // The position of the textarea will be the sum of positions above
        const areaPosition = {
          x: stageBox.left + textPosition.x,
          y: stageBox.top + textPosition.y,
        };

        // Create textarea and style it
        let textarea = document.createElement('textarea');
        document.body.appendChild(textarea);

        textarea.value = textNode.text();
        textarea.style.position = 'absolute';
        textarea.style.top = areaPosition.y + 'px';
        textarea.style.left = areaPosition.x + 'px';
        textarea.style.width = textNode.width();

        textarea.focus();

        const vm = this;
        textarea.addEventListener('keydown', function (e) {
          // hide on enter
          if (e.keyCode === 13) {
            textNode.text(textarea.value);
            vm.$emit('updateTextValue', {text: textarea.value, id: textId});
            vm.$refs.layer.getNode().getLayer().draw();
            document.body.removeChild(textarea);
            vm.$refs.container.removeEventListener('click', handleContainerClick);
          }
        });

        this.textEditing = true;
        const handleContainerClick = () => {
          if (this.textEditing) {
            this.textEditing = false;
          } else {
            textNode.text(textarea.value);
            vm.$emit('updateTextValue', {text: textarea.value, id: textId});
            vm.$refs.layer.getNode().getLayer().draw();
            document.body.removeChild(textarea);
            vm.$refs.container.removeEventListener('click', handleContainerClick);
          }
        };
        this.$refs.container.addEventListener('click', handleContainerClick);
      },
      handleTransformEnd(e) {
        // shape is transformed, let us save new attrs back to the node
        // find element in our state
        const circle = this.filteredCircles.find(r => r.name === this.selectedShapeName);
        // update the state
        circle.x = e.target.x();
        circle.y = e.target.y();
        circle.rotation = e.target.rotation();
        circle.scaleX = e.target.scaleX();
        circle.scaleY = e.target.scaleY();
        circle.radius = 50;
        circle.strokeWidth = 5;
        const subImage = this.retrieveImage(e.target);
        this.$emit('circleChanged', circle);
        this.$emit('textChanged', {x: e.target.x(), y: e.target.y()});
        this.$emit('subImageChanged', {imageURL: subImage});
      },
      handleStageMouseDown(e) {
        // clicked on stage - clear selection
        if (e.target === e.target.getStage()) {
          this.selectedShapeName = '';
          this.changeSelectedCircle();
          this.updateTransformer();
          return;
        }

        // clicked on transformer - do nothing
        const clickedOnTransformer =
          e.target.getParent().className === 'Transformer';
        if (clickedOnTransformer) {
          return;
        }

        // find clicked circle by its name
        const name = e.target.name();
        const circle = this.circles.find(r => r.name === name);
        if (circle) {
          this.selectedShapeName = name;
        } else {
          this.selectedShapeName = '';
        }
        this.changeSelectedCircle();
        this.updateTransformer();
      },
      updateTransformer() {
        // here we need to manually attach or detach Transformer node
        const transformerNode = this.$refs.transformer.getNode();
        const stage = transformerNode.getStage();
        const { selectedShapeName } = this;

        const selectedNode = stage.findOne('.' + selectedShapeName);
        // do nothing if selected node is already attached
        if (selectedNode === transformerNode.node()) {
          return;
        }

        if (selectedNode) {
          // attach to another node
          transformerNode.attachTo(selectedNode);
        } else {
          // remove transformer
          transformerNode.detach();
        }
        transformerNode.getLayer().batchDraw();
      },
    }
  };
</script>

<style scoped>
    #transformationCanvas {
        width: 125px;
        height: 125px;
    }
    .container {
        width: 700px;
        height: 500px;
    }
    canvas {
        border: 5px solid #BADA55;
    }
</style>